;===============================================================
;final CAnimal instance called code
;===============================================================
;NOTE: some of the CAnimal values/members are updated upon level
;restart (i.e., health) while others are not (i.e., Wake values).

CANIMAL_INIT_END_DEST	dd     CANIMAL_INIT_END

CANIMAL_INIT_END:
mov edi,eax		;edi = CAnimal object
mov ebp,[esp]
mov ebp,[ebp]		;ebp=pointer to CAnimal instance name

and [DisplayDino_INDEX],0

cmp eax,2
jb ExitCAnimalBufferCreate

mov esi,[BaseData]

	call IsLevelSavedGame
	test eax,eax
	jnz No_Modify_11222233334444
call ModifyCAnimal_ONCEONLY
	No_Modify_11222233334444:

;===============================================================
;adds last instance to list of CAnimal instances
;===============================================================
       cmp [New_CAnimal_BUF],0
       jz AddToBuf_CANIMAL
;===============================================================
LOCALRELEASE_01 [CAnimal_BUF]
LOCALRELEASE_01 [CAnimal_Names_INDEX]
LOCALRELEASE_01 [CAnimal_Names_BUF]
       and [CAnimal_BUF_SIZE],0
       and [CAnimal_Names_BUF_SIZE],0

invoke LocalAlloc,LMEM_FIXED,4	      ;init CAnimal instance list
       test eax,eax
       jz ExitCAnimalBufferCreate

       mov [CAnimal_BUF],eax
       mov [CAnimal_BUF_SIZE],4
       and [New_CAnimal_BUF],0
       mov [eax],edi

       lea ebx,[ebp-1]
       CountLoopNotDone_CANIMALENDINIT:
       inc ebx
       mov al,[ebx]
       test al,al
       jnz CountLoopNotDone_CANIMALENDINIT
       inc ebx
       sub ebx,ebp		;ebx=string length (CAnimal name)

invoke LocalAlloc,LMEM_FIXED,ebx	;initiate instance name
       test eax,eax
       jz ExitCAnimalBufferCreate
       mov [CAnimal_Names_BUF],eax
       mov [CAnimal_Names_BUF_SIZE],ebx
	  push esi
	  push edi
	  mov esi,ebp
	  mov edi,eax
	  mov ecx,ebx
	  rep movsb		    ;move string (name)
	  pop edi
	  pop esi

invoke LocalAlloc,LMEM_FIXED,4	    ;initiate instance name relative list
       test eax,eax
       jz ExitCAnimalBufferCreate
       mov [CAnimal_Names_INDEX],eax
       mov [eax],DWORD 0

jmp ExitCAnimalBufferCreate
;===============================================================
AddToBuf_CANIMAL:
       mov eax,[CAnimal_BUF_SIZE]
       add eax,4
invoke LocalReAlloc,[CAnimal_BUF],eax,LMEM_MOVEABLE
       test eax,eax
       jz ExitCAnimalBufferCreate
       mov [CAnimal_BUF],eax
       add eax,[CAnimal_BUF_SIZE]
       add [CAnimal_BUF_SIZE],4
       mov [eax],edi			;store CAnimal object pointer

       lea ebx,[ebp-1]
       CountLoopNotDone_CANIMALENDINIT2:
       inc ebx
       mov al,[ebx]
       test al,al
       jnz CountLoopNotDone_CANIMALENDINIT2
       inc ebx
       sub ebx,ebp		;ebx=string length (CAnimal name)

       mov ecx,[CAnimal_Names_BUF_SIZE]
       add ecx,ebx
invoke LocalReAlloc,[CAnimal_Names_BUF],ecx,LMEM_MOVEABLE
       test eax,eax
       jz ExitCAnimalBufferCreate
       mov [CAnimal_Names_BUF],eax
	  push esi
	  push edi
	  mov esi,ebp
	  mov edi,eax
	  add edi,[CAnimal_Names_BUF_SIZE]
	  mov ecx,ebx
	  rep movsb		    ;move string (name)
	  pop edi
	  pop esi
       add [CAnimal_Names_BUF_SIZE],ebx

invoke LocalReAlloc,[CAnimal_Names_INDEX],[CAnimal_BUF_SIZE],LMEM_MOVEABLE
       test eax,eax
       jz ExitCAnimalBufferCreate
       mov [CAnimal_Names_INDEX],eax
       add eax,[CAnimal_BUF_SIZE]
       mov ecx,[CAnimal_Names_BUF_SIZE]
       sub ecx,ebx
       mov [eax-4],ecx
;===============================================================
ExitCAnimalBufferCreate:
	mov eax,edi
	;REPLACED CODE
	pop edi
	pop esi
	pop ebp
	pop ebx
	add esp,0C0h
	ret

;===============================================================
ModifyCAnimal_ONCEONLY:
;===============================================================
;add to instance's Sleep/WakeUp values (not updated after level restart)
     mov edx,[edi+0DCh] 	;sub-object (which contains some Actxxxx objects)
;add to WakeUp
     fld DWORD [edx+340h]
     fadd [UseSleepWake]
     fstp DWORD [edx+340h]
;add to Sleep
     fld DWORD [edx+344h]
     fadd [UseSleepWake]
     fstp DWORD [edx+344h]
;================================================================
ret