;================================================================
;modifies every CAnimal instance in list
;================================================================
;note: the game does not move the instances (during the period
;between the instancing and this code) so the pointers should
;always be valid

ModifyCAnimalInstances:

mov esi,[CAnimal_BUF]
sub esi,4
jb NoModCAnimalInst
mov ebx,[CAnimal_BUF_SIZE]
cmp ebx,4
jb NoModCAnimalInst
add ebx,esi

	CAnimalModLoop:
	add esi,4
	mov edi,[esi]
	call DoMods_CAnimal
	cmp esi,ebx
	jb CAnimalModLoop

NoModCAnimalInst:
ret

;================================================================
DoMods_CAnimal: 	;edi=CAnimal instance
;================================================================

;modify instance's health values (updated after each level restart)
;add to HitPoints
	fld DWORD [edi+50h]
	fadd [UseCAnimalHitPoints]
	fstp DWORD [edi+50h]
;add to MaxHitPoints
	fld DWORD [edi+54h]
	fadd [UseCAnimalHitPoints]
	fstp DWORD [edi+54h]
ret


