;=====================================================
;COUNTER FUNCTIONS
;=====================================================
SetNewTimeStamp:
	cmp [CounterFirstRun],1
	jz FirstRunOnly_Timestamp
	cmp [USE_COUNTER],1
	jz SHOW_COUNTER
	ret

FirstRunOnly_Timestamp:
push eax
push ecx
push edx
	mov [CounterFirstRun],0
	invoke GetTickCount
	mov [FirstTimeStamp],eax
pop edx
pop ecx
pop eax
	cmp [USE_COUNTER],1
	jz SHOW_COUNTER
	ret

;===================================================
;[ebp-4]=hours
;[ebp-8]=minutes
;[ebp-12]=seconds
;ADDR [ebp-100]=buffer for time stamp string (result)

SHOW_COUNTER:
push ebp
mov ebp,esp
sub esp,100
push eax
push ecx
push edx
push esi
push edi
push ebx
mov esi,[BaseData]

	mov eax,[BaseDDSurfaceADDR]
	mov ecx,[eax]
	call [EXEPROC_GETDDSURFDC]	;GetDC for DDraw surface via EXE
	mov edi,eax

	invoke GetTickCount
	sub eax,[FirstTimeStamp]
	mov ebx,eax

	cdq
	mov ecx,(60*60*1000)	;milliseconds/hour
	div ecx 		;get # hours passed
	mov [ebp-4],eax

	mov eax,edx		;remainder=milliseconds left
	cdq
	mov ecx,(60*1000)	;milliseconds/minute
	div ecx
	mov [ebp-8],eax

	mov eax,edx		;remainder=milliseconds left
	cdq
	mov ecx,(1000)		;milliseconds/second
	div ecx
	mov [ebp-12],eax

lea ebx,[ebp-100]
invoke wsprintfA,ebx,Time_Format_String,[ebp-4],[ebp-8],[ebp-12]
	add esp,20
invoke TextOut,edi,0,2Eh,ebx,eax

	mov eax,[BaseDDSurfaceADDR]
	push edi		 ;DDraw ReleaseDC
	mov ecx,[eax]
	call [EXEPROC_RELEASEDDSURFDC]

pop ebx
pop edi
pop esi
pop edx
pop ecx
pop eax
mov esp,ebp
pop ebp
ret